## hyphy 2.2.5+dfsg

=== debian/changelog ===
hyphy (2.2.5+dfsg-1) unstable; urgency=low

  * Initial release (Closes: #792087)

 -- Andreas Tille <tille@debian.org>  Sat, 11 Jul 2015 06:57:36 +0200
