## hyphy 2.2.6+dfsg

=== debian/changelog ===
hyphy (2.2.6+dfsg-4) unstable; urgency=medium

  * Fix gcc-6 build issue by incorporating upstream patch
    Closes: #811866
  * cme fix dpkg-control
  * Fix more spelling errors
  * hardening=+bindnow

 -- Andreas Tille <tille@debian.org>  Fri, 22 Jul 2016 15:05:54 +0200

hyphy (2.2.6+dfsg-3) unstable; urgency=medium

  * Change build-dep on python3-dev to python3-all-dev to enable building for
    all supported python3 versions (thanks to Scott Kitterman
    <debian@kitterman.com> for the patch)
    Closes: #809452

 -- Andreas Tille <tille@debian.org>  Wed, 30 Dec 2015 21:49:03 +0100

hyphy (2.2.6+dfsg-2) unstable; urgency=medium

  [ Matthias Klose ]
  * Hand-edit swig generated file to build with Python3.5.
    Closes: #802999

  [ Andreas Tille ]
  * Remove arch specific flags
    Closes: #802994

 -- Andreas Tille <tille@debian.org>  Mon, 26 Oct 2015 11:20:39 +0100

hyphy (2.2.6+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Hack around a mac-ism in setup.py

 -- Andreas Tille <tille@debian.org>  Tue, 22 Sep 2015 17:50:33 +0200

hyphy (2.2.5+dfsg-2) unstable; urgency=medium

  * Versioned Build-Depends: cmake (>= 3.0)
  * Drop profiling option (Thanks for the hint to Michael Banck
    <mbanck@debian.org>)
    Closes: #793345
  * Disable unneded test that breaks on 32 bit architectures (Thanks for
    the hint to Jakub Wilk <jwilk@debian.org>)
    Closes: #793346
  * Make sure that also in tests the existence of SSE3 extension is done
    Closes: #793344

 -- Andreas Tille <tille@debian.org>  Thu, 23 Jul 2015 17:13:45 +0200
