=== debian/control ===
--- 
+++ 
@@ -5,18 +5,18 @@
 Priority: optional
 Build-Depends: debhelper (>= 9),
                dh-python,
-               cmake,
+               cmake (>= 3.0),
                python-dev,
-               python3-dev,
+               python3-all-dev,
                mpi-default-dev,
                libcurl4-gnutls-dev | libcurl4-dev,
                python,
                libgtk2.0-dev,
                libssl-dev,
                libsqlite3-dev
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/hyphy.git
-Vcs-Git: git://anonscm.debian.org/debian-med/hyphy.git
+Vcs-Git: https://anonscm.debian.org/git/debian-med/hyphy.git
 Homepage: http://hyphy.org/
 X-Python-Version: >= 2.7
 X-Python3-Version: >= 3.4
