=== debian/rules ===
--- 
+++ 
@@ -1,6 +1,9 @@
 #!/usr/bin/make -f
 
 # DH_VERBOSE := 1
+
+# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
+export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
 
 pkg=$(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')
 export PYBUILD_NAME=$(pkg)
@@ -32,7 +35,7 @@
 	# cd src/lib ; bash build.sh LIBRARY R
 
 override_dh_auto_test:
-	./obj-$(DEB_TARGET_GNU_TYPE)/HYPHYGTEST
+	find obj-* -name HYPHYGTEST -exec \{\} \;
 
 override_dh_auto_install:
 	dh_auto_install
