## hyphy 2.2.7+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -109,6 +109,10 @@
         set(GCC46 true)
     endif(${GCC_VERSION} VERSION_GREATER 4.6 OR ${GCC_VERSION} VERSION_EQUAL 4.6)
 
+    if(${GCC_VERSION} VERSION_GREATER 6.0 OR ${GCC_VERSION} VERSION_EQUAL 6.0)
+        set(GCC6 true)
+    endif(${GCC_VERSION} VERSION_GREATER 6.0 OR ${GCC_VERSION} VERSION_EQUAL 6.0)
+
     if(${MACOSX_LION})
         set(DEFAULT_WARNING_FLAGS "-Wno-int-to-pointer-cast -Wno-conversion-null -Wno-dangling-else -Wno-logical-op-parentheses")
     endif(${MACOSX_LION})
@@ -122,7 +126,12 @@
     if(${GCC46})
         set(DEFAULT_WARNING_FLAGS "-Wno-int-to-pointer-cast -Wno-conversion-null")
     endif(${GCC46})
-    
+
+    if(${GCC6})
+      set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -std=gnu++98 -fno-strict-aliasing -fpermissive")
+      set(DEFAULT_WARNING_FLAGS "${DEFAULT_WARNING_FLAGS} -Wno-error=narrowing")
+    endif(${GCC6})
+
     PCL_CHECK_FOR_AVX()
     if(${HAVE_AVX_EXTENSIONS})
         set(DEFAULT_COMPILE_FLAGS "${DEFAULT_COMPILE_FLAGS} -march=corei7-avx -mtune=corei7-avx")
@@ -209,7 +218,7 @@
 file(GLOB SRC_GTESTS tests/gtests/*.cpp)
 file(GLOB SRC_NEW src/new/*.cpp)
 
-set(SRC_LINK src/lib/Link/THyPhy.cpp)
+set(SRC_LINK src/lib/link/THyPhy.cpp)
 set(SRC_PREFS src/gui/preferences.cpp)
 set(SRC_SQLITE3 contrib/SQLite-3.8.2/sqlite3.c)
 set(SRC_UNIXMAIN src/mains/unix.cpp)
@@ -348,14 +357,3 @@
     )
     add_custom_command(
         OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/src/ocl/opencl_kernels.h
-        COMMAND cl2hdr ${CMAKE_CURRENT_SOURCE_DIR}/src/ocl/opencl_kernels.cl ${CMAKE_CURRENT_BINARY_DIR}/src/ocl/opencl_kernels.h
-        DEPENDS cl2hdr ${CMAKE_CURRENT_SOURCE_DIR}/src/ocl/opencl_kernels.cl
-    )
-endif(${OPENCL_FOUND})
-
-
-#-------------------------------------------------------------------------------
-# hyphy mpi target
-#-------------------------------------------------------------------------------
-find_package(MPI)
-
