=== debian/changelog ===
hyphy (2.2.7+dfsg-1) unstable; urgency=medium

  * New upstream version
  * Use xz compression in d/watch
  * python-hyphy is now distributed in separate source archive so
    removing it from this package

 -- Andreas Tille <tille@debian.org>  Fri, 14 Oct 2016 08:01:08 +0200

hyphy (2.2.6+dfsg-5) unstable; urgency=medium

  * Fix error: narrowing conversion from 'double' to 'unsigned char'
  * Fix error: replacing false with nil 
    Closes: #811866

 -- Andreas Tille <tille@debian.org>  Mon, 15 Aug 2016 12:44:58 +0200
