=== debian/control ===
--- 
+++ 
@@ -4,13 +4,9 @@
 Section: science
 Priority: optional
 Build-Depends: debhelper (>= 9),
-               dh-python,
                cmake (>= 3.0),
-               python-dev,
-               python3-all-dev,
                mpi-default-dev,
                libcurl4-gnutls-dev | libcurl4-dev,
-               python,
                libgtk2.0-dev,
                libssl-dev,
                libsqlite3-dev
@@ -18,8 +14,6 @@
 Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/hyphy.git
 Vcs-Git: https://anonscm.debian.org/git/debian-med/hyphy.git
 Homepage: http://hyphy.org/
-X-Python-Version: >= 2.7
-X-Python3-Version: >= 3.4
 
 Package: hyphygui
 Architecture: any
@@ -92,64 +86,3 @@
  .
  This package provides files that are common to all binary versions.
 
-Package: python-hyphy
-Architecture: any
-Section: python
-Depends: ${shlibs:Depends},
-         ${misc:Depends},
-         ${python:Depends},
-         hyphy-common
-Description: Hypothesis testing using Phylogenies (Python 2 module)
- HyPhy is an open-source software package for the analysis of genetic
- sequences using techniques in phylogenetics, molecular evolution, and
- machine learning. It features a complete graphical user interface (GUI)
- and a rich scripting language for limitless customization of analyses.
- Additionally, HyPhy features support for parallel computing environments
- (via message passing interface) and it can be compiled as a shared
- library and called from other programming environments such as Python or
- R.  Continued development of HyPhy is currently supported in part by an
- NIGMS R01 award 1R01GM093939.
- .
- This package provides files the Python 2 module.
-
-Package: python3-hyphy
-Architecture: any
-Section: python
-Depends: ${shlibs:Depends},
-         ${misc:Depends},
-         ${python3:Depends},
-         hyphy-common
-Description: Hypothesis testing using Phylogenies (Python 3 module)
- HyPhy is an open-source software package for the analysis of genetic
- sequences using techniques in phylogenetics, molecular evolution, and
- machine learning. It features a complete graphical user interface (GUI)
- and a rich scripting language for limitless customization of analyses.
- Additionally, HyPhy features support for parallel computing environments
- (via message passing interface) and it can be compiled as a shared
- library and called from other programming environments such as Python or
- R.  Continued development of HyPhy is currently supported in part by an
- NIGMS R01 award 1R01GM093939.
- .
- This package provides files the Python 3 module.
-
-#Package: libhyphy
-#Architecture: any
-#Depends: ${shlibs:Depends},
-#         ${misc:Depends}
-#Description: Hypothesis testing using Phylogenies (library)
-# HyPhy is an open-source software package for the analysis of genetic
-# sequences using techniques in phylogenetics, molecular evolution, and
-# machine learning. It features a complete graphical user interface (GUI)
-# and a rich scripting language for limitless customization of analyses.
-# Additionally, HyPhy features support for parallel computing environments
-# (via message passing interface) and it can be compiled as a shared
-# library and called from other programming environments such as Python or
-# R.  Continued development of HyPhy is currently supported in part by an
-# NIGMS R01 award 1R01GM093939.
-# .
-# This package provides files that a dynamic library.
-# .
-# .
-# The usage is unclear currently and upstream was asked for
-# clarification
-#
