=== debian/changelog ===
hyphy (2.3.13+dfsg-1) unstable; urgency=medium

  * Team upload.

  [ Steffen Moeller ]
  * debian/upstream/metadata: Added ref to OMICtools

  [ Andreas Tille ]
  * New upstream version
  * debhelper 11
  * Add Build-Depends: opencl-dev
  * debian/rules:
     - Do not parse d/changelog
     - regard $(DEB_BUILD_OPTIONS) for override_dh_auto_test

  [ Liubov Chuprikova ]
  * Drop hyphygui as it was removed from upstream
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.5

 -- Liubov Chuprikova <chuprikovalv@gmail.com>  Tue, 10 Jul 2018 08:39:13 +0200
