=== debian/control ===
--- 
+++ 
@@ -3,35 +3,16 @@
 Uploaders: Andreas Tille <tille@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 9),
+Build-Depends: debhelper (>= 11~),
                cmake (>= 3.0),
                mpi-default-dev,
                libcurl4-gnutls-dev | libcurl4-dev,
-               libgtk2.0-dev,
                libssl-dev,
                libsqlite3-dev
-Standards-Version: 3.9.8
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/hyphy.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/hyphy.git
+Standards-Version: 4.1.5
+Vcs-Browser: https://salsa.debian.org/med-team/hyphy
+Vcs-Git: https://salsa.debian.org/med-team/hyphy.git
 Homepage: http://hyphy.org/
-
-Package: hyphygui
-Architecture: any
-Depends: ${shlibs:Depends},
-         ${misc:Depends},
-         hyphy-common
-Description: Hypothesis testing using Phylogenies (GTK+ gui)
- HyPhy is an open-source software package for the analysis of genetic
- sequences using techniques in phylogenetics, molecular evolution, and
- machine learning. It features a complete graphical user interface (GUI)
- and a rich scripting language for limitless customization of analyses.
- Additionally, HyPhy features support for parallel computing environments
- (via message passing interface) and it can be compiled as a shared
- library and called from other programming environments such as Python or
- R.  Continued development of HyPhy is currently supported in part by an
- NIGMS R01 award 1R01GM093939.
- .
- This package contains the GTK+ gui.
 
 Package: hyphy-pt
 Architecture: any
@@ -85,4 +66,3 @@
  NIGMS R01 award 1R01GM093939.
  .
  This package provides files that are common to all binary versions.
-
