=== debian/rules ===
--- 
+++ 
@@ -2,11 +2,11 @@
 
 # DH_VERBOSE := 1
 
-# export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 export DEB_BUILD_MAINT_OPTIONS = hardening=+bindnow
 
-pkg=$(shell dpkg-parsechangelog | awk '/^Source:/ {print $$2}')
-export PYBUILD_NAME=$(pkg)
+include /usr/share/dpkg/default.mk
+
+export PYBUILD_NAME=$(DEB_SOURCE)
 PYVERS = $(shell pyversions -r)
 PY3VERS = $(shell py3versions -r)
 
@@ -21,10 +21,12 @@
 
 override_dh_auto_build:
 	# no idea about the purpose of the dynamic library - executables are not simply linked against it
-	dh_auto_build -- HYPHYGTK MP2 MPI GTEST # LIB
+	dh_auto_build -- MP MPI GTEST # LIB
 
 override_dh_auto_test:
+ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
 	find obj-* -name HYPHYGTEST -exec \{\} \;
+endif
 
 override_dh_install:
 	# smallcaps for executables
